//> ===>
//> Title: Admin Controls Manager
//> Author: Truce
//> ===>

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) {
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	%file=new FileObject();
	%path="config/server/AdminControls/cmdList.txt";
	if(!isFile(%path)) {
		%file.openForWrite(%path);
		%file.writeLine("Kick");
		%file.writeLine("Ban");
		%file.writeLine("UnBan");
		%file.close();
	}
	%file2=new FileObject();
	%path2="config/server/AdminControls/cmdParent.cs";
	%file2.openForWrite(%path2);
	%file2.writeLine("package ACM2 {");
	%file.openForRead(%path);
	while(!%file.isEOF()) {
		%line=%file.readLine();
		RTB_registerPref(%line,"Admin Controls","AdminControls["@%line@"]","list Admin 0 SuperAdmin 1 Host 2","Server_AdminControls",0,0,1);
		%file2.writeLine("	function serverCmd"@%line@"(%cl,%a1,%a2,%a3,%a5,%a6,%a7,%a8,%a9,%a10,%a11,%a12,%a13,%a14,%a15,%a16,%a17,%a18,%a19,%a20) {");
		%file2.writeLine("		if(CheckACM(%cl,\""@%line@"\"))");
		%file2.writeLine("			Parent::serverCmd"@%line@"(%cl,%a1,%a2,%a3,%a5,%a6,%a7,%a8,%a9,%a10,%a11,%a12,%a13,%a14,%a15,%a16,%a17,%a18,%a19,%a20);");
		%file2.writeLine("	}");
	}
	%file2.writeLine("};");
	%file2.writeLine("activatePackage(ACM2);");
	%file.close();
	%file2.close();
	%file.delete();
	%file2.delete();
	exec(%path2);
}
else {
	error("Server_AdminControls: Required mod System_ReturnToBlockland not found!");
	return;
}
package ACM {
	function GameConnection::autoAdminCheck(%cl) {
		%cl.isHost=0;
		if(%cl.isLocalConnection()||%cl.bl_id==getNumKeyID())
			%cl.isHost=1;
		return Parent::autoAdminCheck(%cl);
	}
	function CheckACM(%cl,%cmd) {
		switch($AdminControls[%cmd]) {
			case 0:
				if(%cl.isAdmin||%cl.isSuperAdmin||%cl.isHost)
					return 1;
				%type="\c3Admins\c0, \c3Super Admins\c0, and the \c3Host";
			case 1:
				if(%cl.isSuperAdmin||%cl.isHost)
					return 1;
				%type="\c3Super Admins\c0 and the \c3Host";
			case 2:
				if(%cl.isHost)
					return 1;
				%type="the \c3Host";
		}
		messageClient(%cl,'',"\c0Sorry, only "@%type@" \c0can use the \c3"@%cmd@" \c0command.");
		return 0;
	}
};
activatePackage(ACM);

//> ===>
//> Title: RTB Update Prefs Fix
//> Author: Ephialtes & Space Guy
//> ===>

function serverCmdRTB_updatePrefs(%client,%prefArray)
{
   if(!%client.isSuperAdmin)
      return;
      
   for(%i=0;%i<getFieldCount(%prefArray);%i++)
   {
      %pref = strReplace(getField(%prefArray,%i),",","\t");
      %idA = getField(%pref,0);
      %idB = getField(%pref,1);
      %value = getField(%pref,2);
      
      %entry = $RTB::ServerPref[%idA,%idB];
      
      if(getField(%entry,5) $= 1 && (%client.bl_id !$= getNumKeyID() && findLocalClient() !$= %client))
         continue;
         
      %pref = getField(%entry,1);
      %type = getWord(getField(%entry,2),0);
      eval("%currVal = $"@%pref@";");
      
      if(%type $= "bool")
      {
         if(%value !$= 1 && %value !$= 0)
            continue;
      }
      else if(%type $= "string")
      {
         %max = getWord(getField(%entry,2),1);
         if(strLen(%value) > %max)
            %value = getSubStr(%value,0,%max);
         %value = strReplace(%value,"\"","\\\"");
      }
      else if(%type $= "int")
      {
         if(!isInt(%value))
            continue;
         %min = getWord(getField(%entry,2),1);
         %max = getWord(getField(%entry,2),2);
         
         if(%value < %min)
            %value = %min;
         if(%value > %max)
            %value = %max;
      }
      else if(%type $= "list") //this part edited
      {
         %list = restWords(getField(%entry,2));
         for(%j=0;%j<getWordCount(%list);%j++)
         {
            %word = getWord(%list,%j);
            if(%word $= %value && %j%2 $= 1)
            {
               %foundInList = 1;
               break;
            }
         }
         
         if(!%foundInList)
            continue;
      }
      
      if(%currVal !$= %pref)
      {
         eval("$"@%pref@" = \""@%value@"\";");
         %numChanged++;
         
         %newPrefArray = %newPrefArray@%idA@","@%idB@","@%value@"\t";
      }
   }
   
   commandtoclient(%client,'RTB_closeGui',"RTB_ServerControl");
   if(%numChanged <= 0)
      return;
      
   %newPrefArray = getFields(%newPrefArray,0,getFieldCount(%newPrefArray)-1);
   
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl.isSuperAdmin)
         commandtoclient(%cl,'RTB_updatePrefs',%newPrefArray);
   }
   
   messageAll('MsgAdminForce','\c3%1 \c0updated the server preferences.',%client.name);
   
   %file = new FileObject();
   %file.openForWrite("config/server/RTB/modPrefs.cs");
   for(%i=0;%i<$RTB::ServerPrefs;%i++)
   {
      for(%j=1;%j<$RTB::ServerPrefCount[%i];%j++)
      {
         eval("%prefValue = $"@getField($RTB::ServerPref[%i,%j],1)@";");
         %file.writeLine("$"@getField($RTB::ServerPref[%i,%j],1)@" = \""@%prefValue@"\";");
      }
   }
   %file.delete();
   
   export("$Pref::Server::*","config/server/prefs.cs");
}